require "util"
require "story"local settings = require("settings")
distraction = defines.distraction.by_anything
global.team1Player = nil
global.team2Player = nil
global.team1Master = nil
global.team2Master = nil
global.team1Accesschest = nil
global.team2Accesschest = nil
global.team1MasterConnected = false
global.team2MasterConnected = false
global.team1StoredPlayer = nil
global.team2StoredPlayer = nil

global.team1Spawn = {}
global.team1Spawn["x"] = 0
global.team1Spawn["y"] = 0
global.team2Spawn = {}
global.team2Spawn["x"] = 0
global.team2Spawn["y"] = 0

global.team1MasterSpawn = {}
global.team1MasterSpawn["x"] = 0
global.team1MasterSpawn["y"] = 0
global.team2MasterSpawn = {}
global.team2MasterSpawn["x"] = 0
global.team2MasterSpawn["y"] = 0

global.validSeed = false

local settings = require("settings")
global.gracePeriod = settings.gracePeriod

local transferableItems = 
{
	"small-biter",
	"medium-biter",
	"big-biter",
	"behemoth-biter",
	"small-spitter",
	"medium-spitter",
	"big-spitter",
	"small-worm-turret",
	"medium-worm-turret",
	"big-worm-turret",
	"biter-spawner",
	"spitter-spawner"
}
local validSeeds = {}
for _,v in ipairs(settings.validSeeds) do 
table.insert(validSeeds, v)
end

function startingItems(targetPlayer)
	game.players[targetPlayer].insert{name="market", count=1}
	game.players[targetPlayer].insert{name="coin", count=settings.startingCoins}
	game.players[targetPlayer].insert{name="stone-furnace", count=3}
	game.players[targetPlayer].insert{name="burner-mining-drill", count=4}
	game.players[targetPlayer].insert{name="burner-inserter", count=4}
	game.players[targetPlayer].insert{name="wooden-chest", count=4}
	game.players[targetPlayer].insert{name="pistol", count=1}
	game.players[targetPlayer].insert{name="steel-axe", count=1}
	game.players[targetPlayer].insert{name="lab", count=1}
	game.players[targetPlayer].insert{name="boiler", count=1}
	game.players[targetPlayer].insert{name="steam-engine", count=1}
	game.players[targetPlayer].insert{name="piercing-rounds-magazine", count=5}
	game.players[targetPlayer].insert{name="iron-plate", count=100}
	game.players[targetPlayer].insert{name="copper-plate", count=100}
	if settings.turretStart == true then
		game.players[targetPlayer].insert{name="gun-turret", count=1}
	end
end

script.on_event(defines.events.on_built_entity, function(event)
    if global.validSeed == true then
		local entityMade = event.created_entity
		if entityMade.name == "market" then
			getMarketItems(entityMade)
			--entityMade.destructible = false
		end
		if entityMade.name == "access-chest" then
			if global.team1Player == event.player_index then
				game.players[global.team1Player].print("Access made")
				global.team1Accesschest = entityMade
			end
			if global.team2Player == event.player_index then
				game.players[global.team2Player].print("Access made")
				global.team2Accesschest = entityMade
			end
		end
		biterEntityPlaceRestricter(entityMade,event.player_index)
	end
end)

script.on_event(defines.events.on_player_mined_item, function(event)
	if global.validSeed == true then
		entityMined = event.item_stack
		accessChestMined(entityMined)
	end
end)

script.on_event(defines.events.on_player_created, function(event)
	if global.validSeed == true then
		local entityMade = event.player_index
		assignPlayerForce(entityMade)
		if global.validSeed == true then
			game.players[entityMade].print("World is a valid HIVE WARS scenario")
		else
			game.players[entityMade].print("World is NOT a valid HIVE WARS scenario")
		end
			game.players[entityMade].gui.top.add{type = "button", caption = "Swap Character", name = "Swap_Button"} 
	end
end)

script.on_event(defines.events.on_gui_click, function(event)
	if global.validSeed == true then
		if math.floor(game.tick / 60) > global.gracePeriod then
			if (event.element.name == "Swap_Button") then
					if event.player_index == global.team1Player then
						global.team1MasterConnected, global.team1StoredPlayer, global.team1Master = swapCharacter(global.team1Master, global.team1MasterConnected,global.team1StoredPlayer, global.team1Player)
					end
					if event.player_index == global.team2Player then
						global.team2MasterConnected, global.team2StoredPlayer, global.team2Master = swapCharacter(global.team2Master, global.team2MasterConnected,global.team2StoredPlayer, global.team2Player)
					end
				end
			else
			timeLeft = global.gracePeriod-math.floor( LuaGameScript .tick / 60)
			game.players[event.player_index].print("You must wait "..timeLeft.." seconds before you can switch to your master.")
		end
	end
end)

script.on_init(function()
	if settings.onlyScenarios == true then
		if isValidSeed(game.surfaces[1].map_gen_settings.seed) then
			global.validSeed = true
		end
	else
		global.validSeed = true
	end
	determineSpawnLocations()
	game.create_force('team1')
	game.create_force('team2')
	game.forces['team1'].set_spawn_position({x = global.team1Spawn["x"], y = global.team1Spawn["y"]}, game.surfaces[1])
	game.forces['team2'].set_spawn_position({x = global.team2Spawn["x"], y = global.team2Spawn["y"]}, game.surfaces[1])
    loadPlayers()
end)
	
script.on_event(defines.events.on_tick, function(event)
	if global.validSeed == true then
		updateMasterInventories()
	end
end)

function determineSpawnLocations()
	seedSpawnInfo = {}
	for _,v in ipairs(settings.seedSpawnInfo) do 
    table.insert(seedSpawnInfo, v)
	end
	
	for i=#seedSpawnInfo,1,-1 
	do
		if seedSpawnInfo[i][1].." " == game.surfaces[1].map_gen_settings.seed.." " then
			--game.player.print("Value Found!")
			global.team1Spawn["x"] = seedSpawnInfo[i][2]
			global.team1Spawn["y"] = seedSpawnInfo[i][3]
			global.team2Spawn["x"] = seedSpawnInfo[i][4]
			global.team2Spawn["y"] = seedSpawnInfo[i][5]

			global.team1MasterSpawn["x"] = seedSpawnInfo[i][6]
			global.team1MasterSpawn["y"] = seedSpawnInfo[i][7]
			global.team2MasterSpawn["x"] = seedSpawnInfo[i][8]
			global.team2MasterSpawn["y"] = seedSpawnInfo[i][9]
			break
		end
	end
end

function addMarketItem(entity, cost, amount, reward)
	entity.add_market_item{price={{cost, amount}}, offer={type="give-item", item=reward}}
end

function biterEntityPlaceRestricter(entityMade,playerIndex)
	if isBiterItem(entityMade.name) == true then
		if global.team1Player == playerIndex then
			if global.team1MasterConnected == false then
				game.players[global.team1Player].insert{name=entityMade.prototype.name, count=1}
				entityMade.destroy()
			else
				attackArea(entityMade, game.players[playerIndex])
			end
		end
		if global.team2Player == playerIndex then
			if global.team2MasterConnected == false then
				game.players[global.team2Player].insert{name=entityMade.prototype.name, count=1}
				entityMade.destroy()
			else
				attackArea(entityMade, game.players[playerIndex])
			end
		end
	end
end

function attackArea(entityMade, player)
	if entityMade.name ~= "biter-spawner" then
			if entityMade.name ~= "spitter-spawner" then
				if entityMade.name ~= "small-worm-turret" then
					if entityMade.name ~= "medium-worm-turret" then
						if entityMade.name ~= "big-worm-turret" then
							distanceFromAlien = distanceFrom(player.position.x,player.position.y,entityMade.position.x,entityMade.position.y)
							if distanceFromAlien <= 2 then 
								attackRadius = 8 
								else 
									if distanceFromAlien <= 3 then
										attackRadius = 16
									else
										if distanceFromAlien <= 4 then
											attackRadius = 32
										else
											if distanceFromAlien > 4 then
												attackRadius = 64
										end
									end
								end
							end
							entityMade.set_command({ type=defines.command.attack_area, destination={x=entityMade.position.x, y=entityMade.position.y}, radius=attackRadius, distraction=defines.distraction.by_anything})
						end
					end
				end
			end
	end
end

function getMarketItems(entityMade)
	addMarketItem(entityMade, "coin", 5, "accesschest")
	addMarketItem(entityMade, "coin", math.floor(settings.smallBiterCost*1.5), "small-biter")
	addMarketItem(entityMade, "coin", math.floor(settings.mediumBiterCost*1.5), "medium-biter")
	addMarketItem(entityMade, "coin", math.floor(settings.bigBiterCost*1.5), "big-biter")
	addMarketItem(entityMade, "coin", math.floor(settings.behemothBiterCost*1.5), "behemoth-biter")
	addMarketItem(entityMade, "coin", math.floor(settings.smallSpitterCost*1.5), "small-spitter")
	addMarketItem(entityMade, "coin", math.floor(settings.mediumSpitterCost*1.5), "medium-spitter")
	addMarketItem(entityMade, "coin", math.floor(settings.bigSpitterCost*1.5), "big-spitter")
	addMarketItem(entityMade, "coin", math.floor(settings.smallWormCost*1.5), "small-worm-turret")
	addMarketItem(entityMade, "coin", math.floor(settings.mediumWormCost*1.5), "medium-worm-turret")
	addMarketItem(entityMade, "coin", math.floor(settings.bigWormCost*1.5), "big-worm-turret")
	addMarketItem(entityMade, "coin", math.floor(settings.biterSpawnerCost*1.5), "biter-spawner")
	addMarketItem(entityMade, "coin", math.floor(settings.spitterSpawnerCost*1.5), "spitter-spawner")
end

function isBiterItem(itemCheck)
	for _, item in ipairs(transferableItems) do
		if itemCheck == item then
			return true
		end
	end
	return false
end

function isValidSeed(seed)
	for _, item in ipairs(validSeeds) do
		derp = item
		if seed.." " == item.." " then
			return true
		end
	end
	return false
end

function accessChestMined(entityMined)
	if entityMined.name == "accesschest" then
		if global.team1Accesschest ~= nil then
			if global.team1Accesschest.valid == false then
				global.team1Accesschest = nil
			end
		end
		if global.team2Accesschest ~= nil then
			if global.team2Accesschest.valid == false then
				global.team2Accesschest = nil
			end
		end
	end
end

function updateMasterInventories()
	if global.team1Master ~= nil then
		if global.team1Accesschest ~= nil then
			for _, item in ipairs(transferableItems) do
				transferItemFromAccessChest(item, global.team1Accesschest, global.team1Master)
			end
		end
	end
	if global.team2Master ~= nil then
		if global.team2Accesschest ~= nil then
			for _, item in ipairs(transferableItems) do
				transferItemFromAccessChest(item, global.team2Accesschest, global.team2Master)
			end
		end
	end
end

function swapCharacter(targetMaster, masterConnected,storedPlayer, playerIndex)
	if targetMaster~= nil then
		if masterConnected == false then
			storedPlayer = game.players[playerIndex].character
			game.players[playerIndex].character = targetMaster
			game.players[playerIndex].print("Switched to master.")
			return true, storedPlayer, targetMaster
		else
			if storedPlayer.valid == true then
				targetMaster = game.players[playerIndex].character
				game.players[playerIndex].character = storedPlayer
				game.players[playerIndex].print("Switched back to human form.")
				return false, storedPlayer, targetMaster
			else
				game.players[playerIndex].print("Debug 1")
				if game.players[playerIndex].force == game.forces['team1'] then
					game.players[playerIndex].print("Debug 2")
					targetMaster = game.players[playerIndex].character
					storedPlayer = game.surfaces[1].create_entity{name = "player", position = {global.team1Spawn["x"], global.team1Spawn["y"]}, force=game.forces['team1']}
					game.players[playerIndex].character = storedPlayer
					game.players[playerIndex].print("Switched back to human form.")
					return false, storedPlayer, targetMaster
				end
				if game.players[playerIndex].force == game.forces['team2'] then
					targetMaster = game.players[playerIndex].character
					storedPlayer = game.surfaces[1].create_entity{name = "player", position = {global.team2Spawn["x"], global.team2Spawn["y"]}, force=game.forces['team2']}
					game.players[playerIndex].character = storedPlayer
					game.players[playerIndex].print("Switched back to human form.")
					return false, storedPlayer, targetMaster
				end
			end
		end
	else
		return false, storedPlayer, targetMaster
	end
end

function assignPlayerForce(entityMade)
	if global.team1Player == nil then
		global.team1Player = entityMade
		game.players[global.team1Player].force = game.forces['team1']
		global.team1Master = game.surfaces[1].create_entity{name = "bitermaster", position = {global.team1MasterSpawn["x"], global.team1MasterSpawn["y"]}, force=game.players[entityMade].force}
		game.players[entityMade].teleport{global.team1Spawn["x"], global.team1Spawn["y"]}
		global.team1Master.destructible = false
		startingItems(entityMade)
		game.forces.team1.chart(game.players[entityMade].surface, {{x = -1024, y = -1024}, {x = 2048, y = 2048}})
		game.players[entityMade].print("Team 1")
	else
	if global.team2Player == nil then
		global.team2Player = entityMade
		game.players[global.team2Player].force = game.forces['team2']
		global.team2Master = game.surfaces[1].create_entity{name = "bitermaster", position = {global.team2MasterSpawn["x"], global.team2MasterSpawn["y"]}, force=game.players[entityMade].force}
		game.players[entityMade].teleport{global.team2Spawn["x"], global.team2Spawn["y"]}
		global.team2Master.destructible = false
		startingItems(entityMade)
		game.forces.team2.chart(game.players[entityMade].surface, {{x = -1024, y = -1024}, {x = 2048, y = 2048}})
		game.players[entityMade].print("Team 2")
	end
	end
end

function transferItemFromAccessChest(itemname, accesschest, target)
	if accesschest.valid == true then
		if accesschest.get_item_count(itemname) > 0 then
			target.insert{name=itemname, count=accesschest.get_item_count(itemname)}
			accesschest.get_inventory(defines.inventory.chest).remove({name=itemname, count=accesschest.get_item_count(itemname)})
		end
	end
end

function loadPlayers()
	if global.team1Player ~= nil then
		global.team1Player.force = game.forces['team1']
	end
	if global.team2Player ~= nil then
		global.team2Player.force = game.forces['team2']
	end
end

function distanceFrom(x1,y1,x2,y2) return math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2) end